﻿Type=Class
Version=4.01
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private domain As String
	Private mTarget As Object
	Private mEventName As String
	Private EntriesList As List 
	Private SignUp_Process As Boolean
	Private LogIn_Password, LogIn_User As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (Target As Object, EventName As String)
	EntriesList.Initialize
	mTarget = Target
	mEventName = EventName
	domain = Main.mydomain
End Sub

#Region LogIn Pane
	Public Sub GetUserName(SignUpBool As Boolean, user As String, password As String)
		SignUp_Process = SignUpBool 'check if Login (Login=False) or SignUp (Signup=True)
		LogIn_Password = password
		LogIn_User = user
		Dim GetPersons As HttpJob
	    GetPersons.Initialize("GetUserN", Me)
	    GetPersons.download2(domain & "b4login.php", Array As String ("action", "GetUserName", "username", user))	
	End Sub
	
	Public Sub SignUp(user As String, password As String)
		Dim GetPersons As HttpJob
	    GetPersons.Initialize("SignUp", Me)
	    GetPersons.download2(domain & "b4login.php", Array As String ("action", "SignUp","username", user, "password", password))
	End Sub
#End Region

#Region Persons Pane
	Public Sub GetAllEntries
		Dim GetPersons As HttpJob
	    GetPersons.Initialize("GetP", Me)
	    GetPersons.download2(domain & "b4ascript.php", Array As String ("action" , "GetPersons"))
	End Sub

	Public Sub CountEntries 
		Dim CountPersons As HttpJob
	    CountPersons.Initialize("CountP", Me)
	    CountPersons.download2(domain & "b4ascript.php", Array As String ("action", "CountPersons"))
	End Sub

	Public Sub EnterNewEntry (values() As String)
		Dim InsertNewPerson As HttpJob
		InsertNewPerson.Initialize("InsertNewP", Me)	
	    InsertNewPerson.download2(domain & "b4ascript.php", values) ' Array As String("action", "InsertNewPerson", values(0),values(1),values(2),values(3),values(4),values(5),values(6),values(7),values(8),values(9),values(10),values(11)))
	End Sub

	Public Sub DeleteEntry(id As Int)
		Dim DelPerson As HttpJob
	    DelPerson.Initialize("DelP", Me)
	    DelPerson.download2(domain & "b4ascript.php", Array As String ("action", "DelPerson", "id", id))
	End Sub

	Public Sub UpdateEntrie(values() As String)
		Dim UpdatePersonHTTP As HttpJob
	    UpdatePersonHTTP.Initialize("UpdateP", Me)
	    UpdatePersonHTTP.download2(domain & "b4ascript.php", values)' Array As String("action", "UpdatePerson",values(0),values(1),values(2),values(3),values(4),values(5),values(6),values(7),values(8),values(9),values(10),values(11)))
	End Sub
	
	Private Sub ReturnBaldString(txt As String) As String
		Dim getstring As String = txt 
		Dim replacechars As String = "{}[]#\/" & """" 
		For i = 0 To replacechars.Length - 1
			getstring = getstring.Replace(replacechars.CharAt(i),"")
		Next	
		
		Return getstring
	End Sub
#End Region

Private Sub JobDone(Job As HttpJob)
	If Job.Success Then
	    Dim res As String
		res = Job.GetString
		Log("Back from Job:" & Job.JobName)
		Log("Response from server: " & res)
		Select Job.JobName
			Case "GetUserN"
				Select SignUp_Process 
					Case True 'If true then check if username exist, if not exist create new and login
						Dim getstring As String = ReturnBaldString(res)

						If getstring.Length > 4 Then
							fx.Msgbox(Main.MainForm,"Username allready exist, please choose another Username","Error")
							CallSub3(mTarget, mEventName & "_LogInSuccess", False, "signup")
						Else 
							SignUp(LogIn_User, LogIn_Password)
						End If
					Case False 'if false then check if username exist, if exist check if password is correct
						Dim getstring As String = ReturnBaldString(res)
						
						If getstring.Length < 4 Then
							fx.Msgbox(Main.MainForm,"Username does not exists, please try again","Error")
							CallSub3(mTarget, mEventName & "_LogInSuccess", False,"signup")
						Else 'check if password is correct
							Dim getstring As String = ReturnBaldString(res)	
							
							Dim str() As String = Regex.Split(":",getstring)
							If str(1) = LogIn_Password Then 
								CallSub3(mTarget, mEventName & "_LogInSuccess", True,"login")
							Else 
								CallSub3(mTarget, mEventName & "_LogInSuccess", False,"login")
							End If		
						End If	
				End Select			
			Case "SignUp"
				If res.Contains("Inserted") Then
					CallSub3(mTarget, mEventName & "_LogInSuccess", True, "signup")
				End If
			Case "GetP"
				EntriesList.Clear
				Dim getstring As String = ReturnBaldString(res)
				If getstring.Length < 4 Then Return 
				Dim split_txt As String
				Dim str() As String = Regex.Split(",",getstring)		
				For i = 0 To str.Length - 1 Step Main.TableSize 
					split_txt = ""
					For i2 = 0 To Main.TableSize - 1 
						Dim str2() As String = Regex.Split(":",str(i+i2))
						split_txt = split_txt & str2(1) 
						If i2 < (Main.TableSize - 1) Then split_txt = split_txt & ", "
					Next	
					EntriesList.Add(split_txt)
				Next
				CallSub2(mTarget, mEventName & "_GetEntries", EntriesList)
			Case "CountP"
				Dim getstring As String = ReturnBaldString(res)
				CallSub2(mTarget, mEventName & "_CountEntries", getstring)
			Case "InsertNewP"
				If res.Contains("Inserted") Then
					GetAllEntries 'update listview
					fx.Msgbox(Main.MainForm,"New contact entered succefully","Info")
				End If
			Case "UpdateP"
				If res.Contains("Updated") Then 
					GetAllEntries'update listview
					fx.Msgbox(Main.Mainform,"Contact updated succefully","Info")
				End If
			Case "DelP"
				If res.Contains("Deleted") Then 
					GetAllEntries 'update listview
					fx.Msgbox(Main.MainForm,"Contact deleted succefully","info")
				End If
		End Select
	Else
		Log("Error: " & Job.ErrorMessage)
	End If
	Job.Release
End Sub